window.Gleam.initSearch([{"doc":"jasper","title":"jasper","content":"# jasper\n\n[![Package Version](https://img.shields.io/hexpm/v/jasper)](https://hex.pm/packages/jasper)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/jasper/)\n\n```sh\ngleam add jasper\n```\n```gleam\nimport gleam/io\nimport jasper.{parse_json, query_json, String, Root, Key, Index}\n\npub fn main() {\n  let assert Ok(json) = parse_json(&quot;{ \\&quot;foo\\&quot;: [1, true, \\&quot;hi\\&quot;] }&quot;)\n  let assert Ok(String(str)) = query_json(json, Root |&gt; Key(&quot;foo&quot;) |&gt; Index(2))\n  io.println(str)\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/jasper&gt;.\n\n## Development\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n","url":"index.html"},{"doc":"jasper","title":"Indentation","content":"pub type Indentation {\n  Spaces(Int)\n  Tab\n  Tabs(Int)\n}\n\nSpaces(Int)\n\n\nTab\n\n\nTabs(Int)\n\n\nSynonyms:\njasper.Indentation\njasper Indentation","url":"jasper.html#Indentation"},{"doc":"jasper","title":"JsonArray","content":"pub type JsonArray =\n  List(JsonValue)\n\n\nSynonyms:\njasper.JsonArray\njasper JsonArray","url":"jasper.html#JsonArray"},{"doc":"jasper","title":"JsonObject","content":"pub type JsonObject =\n  Dict(String, JsonValue)\n\n\nSynonyms:\njasper.JsonObject\njasper JsonObject","url":"jasper.html#JsonObject"},{"doc":"jasper","title":"JsonQuery","content":"pub type JsonQuery {\n  Root\n  Key(query: JsonQuery, key: String)\n  KeyOr(query: JsonQuery, key: String, or: JsonValue)\n  Index(query: JsonQuery, index: Int)\n  IndexOr(query: JsonQuery, index: Int, or: JsonValue)\n  Filter(query: JsonQuery, predicate: fn(JsonValue) -&gt; Bool)\n  Map(query: JsonQuery, mapping: fn(JsonValue) -&gt; JsonValue)\n  MapKeys(query: JsonQuery, mapping: fn(String) -&gt; String)\n  MapValues(\n    query: JsonQuery,\n    mapping: fn(String, JsonValue) -&gt; JsonValue,\n  )\n  FilterMap(\n    query: JsonQuery,\n    mapping: fn(JsonValue) -&gt; Result(JsonValue, Nil),\n  )\n  ForEach(query: JsonQuery)\n  ForEachOk(query: JsonQuery)\n}\n\nRoot\n\n\nKey(query: JsonQuery, key: String)\n\n\nKeyOr(query: JsonQuery, key: String, or: JsonValue)\n\n\nIndex(query: JsonQuery, index: Int)\n\n\nIndexOr(query: JsonQuery, index: Int, or: JsonValue)\n\n\nFilter(query: JsonQuery, predicate: fn(JsonValue) -&gt; Bool)\n\n\nMap(query: JsonQuery, mapping: fn(JsonValue) -&gt; JsonValue)\n\n\nMapKeys(query: JsonQuery, mapping: fn(String) -&gt; String)\n\n\nMapValues(\n  query: JsonQuery,\n  mapping: fn(String, JsonValue) -&gt; JsonValue,\n)\n\n\nFilterMap(\n  query: JsonQuery,\n  mapping: fn(JsonValue) -&gt; Result(JsonValue, Nil),\n)\n\n\nForEach(query: JsonQuery)\n\n\nForEachOk(query: JsonQuery)\n\n\nSynonyms:\njasper.JsonQuery\njasper JsonQuery","url":"jasper.html#JsonQuery"},{"doc":"jasper","title":"JsonQueryError","content":"pub type JsonQueryError {\n  UnexpectedType(JsonValue)\n  MissingObjectKey(JsonValue, key: String)\n  IndexOutOfBounds(JsonValue, index: Int)\n}\n\nUnexpectedType(JsonValue)\n\n\nMissingObjectKey(JsonValue, key: String)\n\n\nIndexOutOfBounds(JsonValue, index: Int)\n\n\nSynonyms:\njasper.JsonQueryError\njasper JsonQueryError","url":"jasper.html#JsonQueryError"},{"doc":"jasper","title":"JsonValue","content":"pub type JsonValue {\n  Object(JsonObject)\n  Array(JsonArray)\n  String(String)\n  Number(Float)\n  Boolean(Bool)\n  Null\n}\n\nObject(JsonObject)\n\n\nArray(JsonArray)\n\n\nString(String)\n\n\nNumber(Float)\n\n\nBoolean(Bool)\n\n\nNull\n\n\nSynonyms:\njasper.JsonValue\njasper JsonValue","url":"jasper.html#JsonValue"},{"doc":"jasper","title":"ParseError","content":"pub type ParseError {\n  UnexpectedToken(found: Char)\n  UnexpectedEndOfInput\n}\n\nUnexpectedToken(found: Char)\n\n\nUnexpectedEndOfInput\n\n\nSynonyms:\njasper.ParseError\njasper ParseError","url":"jasper.html#ParseError"},{"doc":"jasper","title":"parse_json","content":"pub fn parse_json(value: String) -&gt; Result(JsonValue, ParseError)\n\nSynonyms:\njasper.parse_json\njasper parse_json","url":"jasper.html#parse_json"},{"doc":"jasper","title":"parse_jsonl","content":"pub fn parse_jsonl(\n  value: String,\n) -&gt; Result(List(JsonValue), ParseError)\n\nSynonyms:\njasper.parse_jsonl\njasper parse_jsonl","url":"jasper.html#parse_jsonl"},{"doc":"jasper","title":"parse_jsonl_all","content":"pub fn parse_jsonl_all(\n  value: String,\n) -&gt; List(Result(JsonValue, ParseError))\n\nSynonyms:\njasper.parse_jsonl_all\njasper parse_jsonl_all","url":"jasper.html#parse_jsonl_all"},{"doc":"jasper","title":"parse_jsonl_valid","content":"pub fn parse_jsonl_valid(value: String) -&gt; List(JsonValue)\n\nSynonyms:\njasper.parse_jsonl_valid\njasper parse_jsonl_valid","url":"jasper.html#parse_jsonl_valid"},{"doc":"jasper","title":"query_json","content":"pub fn query_json(\n  json: JsonValue,\n  query: JsonQuery,\n) -&gt; Result(JsonValue, JsonQueryError)\n\nSynonyms:\njasper.query_json\njasper query_json","url":"jasper.html#query_json"},{"doc":"jasper","title":"stringify_json","content":"pub fn stringify_json(value: JsonValue) -&gt; String\n\nSynonyms:\njasper.stringify_json\njasper stringify_json","url":"jasper.html#stringify_json"},{"doc":"jasper","title":"stringify_json_spaced","content":"pub fn stringify_json_spaced(\n  value: JsonValue,\n  indentation: Indentation,\n) -&gt; String\n\nSynonyms:\njasper.stringify_json_spaced\njasper stringify_json_spaced","url":"jasper.html#stringify_json_spaced"},{"doc":"jasper","title":"stringify_jsonl","content":"pub fn stringify_jsonl(values: List(JsonValue)) -&gt; String\n\nSynonyms:\njasper.stringify_jsonl\njasper stringify_jsonl","url":"jasper.html#stringify_jsonl"},{"doc":"jasper","title":"jasper","content":"","url":"jasper.html"}]);